// FrameSelectDialog.cpp : implementation file
//

#include "stdafx.h"
#include "menushrink.h"
#include "FrameSelectDialog.h"
#include "MenuShrinkEngine.h"
#include "DVDPreview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern int CurrentLangage;
extern int NoOverlayMode;

/////////////////////////////////////////////////////////////////////////////
// CFrameSelectDialog dialog


CFrameSelectDialog::CFrameSelectDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CFrameSelectDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFrameSelectDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_Preview = new CDVDPreview();
	m_MyRect = CRect(400,400,400+360,400+240);
	m_Auto = 0;

	m_StartLBA = 0;
	m_EndLBA = 0;
	m_DefaultLBA = 0;
	m_SelectedLBA = 0;
	m_Title = NULL;
	m_FileName = NULL;
	m_PreviewHWND = 0;
	m_VOBID = 0;
	m_CELLID = 0;
	m_VTSIndex = 0;
	m_Kill = 0;
	m_NormallySkipped = 0;
	ResetInfo();
}

CFrameSelectDialog::~CFrameSelectDialog()
{
	delete m_Preview;
}

void CFrameSelectDialog::ResetInfo()
{
	m_Kill = 0;
	m_CellInfoSize = 0;
	memset(m_CellInfo,0,sizeof(m_CellInfo));
	m_VTSIndex = 0;
}

void CFrameSelectDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFrameSelectDialog)
	DDX_Control(pDX, IDC_FRAMESLIDER, m_FrameSlider);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFrameSelectDialog, CDialog)
	//{{AFX_MSG_MAP(CFrameSelectDialog)
	ON_BN_CLICKED(IDC_LEFT, OnLeft)
	ON_BN_CLICKED(IDC_RIGHT, OnRight)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_AUTO, OnAuto)
	ON_WM_MOVE()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_END, OnEnd)
	ON_BN_CLICKED(IDC_SKIP, OnKill)
	ON_BN_CLICKED(IDC_ABORT, OnCancel)
	ON_BN_CLICKED(IDC_KEEP, OnKeep)
	//}}AFX_MSG_MAP
	ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnToolTipNotify )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFrameSelectDialog message handlers

void CFrameSelectDialog::OnCancel() 
{
	ShrinkEngine->m_AbortNow = TRUE;
	OnOK();
}

void CFrameSelectDialog::OnLeft() 
{
	if(m_Preview->GetCurrentSector() > m_StartLBA + 1)
		m_Preview->GoToPreviousVideoFrame();
	UpdateSlider();
}

void CFrameSelectDialog::OnRight() 
{
	if(m_Preview->GetCurrentSector() < m_EndLBA - 1)
		m_Preview->GoToNextVideoFrame();
	UpdateSlider();
}
void CFrameSelectDialog::OnStart() 
{
	m_Preview->GoToSector(m_StartLBA);
	UpdateSlider();
}

void CFrameSelectDialog::OnEnd() 
{
	m_Preview->GoToSector(m_EndLBA);
	UpdateSlider();
}

void CFrameSelectDialog::UpdateSlider()
{
	m_Preview->WaitForThread();
	m_FrameSlider.SetPos(m_Preview->GetCurrentSector());
}

void CFrameSelectDialog::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	switch(pScrollBar->GetDlgCtrlID())
	{
	case IDC_FRAMESLIDER : 
		m_Preview->GoToSector(m_FrameSlider.GetPos()); 
		break;
	default: break;
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

BOOL CFrameSelectDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Button text stuff...
	if(CurrentLangage == FRENCH)
	{
// 
		if(!m_NormallySkipped)
			SetDlgItemText(IDOK,"OK");
		else
			SetDlgItemText(IDOK,"Tue");
		SetDlgItemText(IDC_ABORT,"Annul.");
		SetDlgItemText(IDC_AUTO,"Auto.");
		SetDlgItemText(IDC_KEEP,"Garder");
	}
	else
	{
		if(!m_NormallySkipped)
			SetDlgItemText(IDOK,"Shrink");
		else
			SetDlgItemText(IDOK,"Kill");
	}
	// Initialize our DVD preview class.
	m_PreviewHWND = m_Preview->InitPreview(m_hWnd, .9f, -1, 5, 30, SW_SHOW, true, WS_CHILD, NoOverlayMode);
m_Preview->SetDrawButtons(true);
	// Load the file, and wait until it's actually done!
	m_Preview->LoadFile(m_FileName);
	m_Preview->WaitForThread();
	SetWindowText(m_Title);
	m_FrameSlider.SetRangeMin(m_StartLBA);
	m_FrameSlider.SetRangeMax(m_EndLBA);
	m_SelectedLBA = m_DefaultLBA;
	m_Kill = 0;

	// Look to see if we have previously stored a selected image for this VOB/CELL ID.
	SetDefaultLBA();
	// Set the slider position, and tell the preview to go to that sector.
	m_FrameSlider.SetPos(m_DefaultLBA-1);
	m_Preview->GoToSector(m_DefaultLBA-1);

	// Reposition our window.
	SetWindowPos(NULL,m_MyRect.left,m_MyRect.top,m_MyRect.right-m_MyRect.left,
		m_MyRect.bottom-m_MyRect.top,SWP_NOZORDER);

//	AdjustSize();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CFrameSelectDialog::SetDefaultLBA()
{
	// Look to see if we have previously stored a selected image for this VOB/CELL ID.
	// If we didn't m_SelectedLBA will be unchanged. If we did, it will be replaced by the one
	// stored in our info.
	int i;
	for(i=0;i<m_CellInfoSize;i++)
	{
		if(m_VOBID == m_CellInfo[i].VOBID && m_CELLID == m_CellInfo[i].CellID && 
			m_VTSIndex == m_CellInfo[i].VTSIndex && m_CellInfo[i].SelectedFrame >= 0)
		{
			m_SelectedLBA = m_DefaultLBA = m_CellInfo[i].SelectedFrame;
			break;
		}
	}
}

void CFrameSelectDialog::OnAuto() 
{
	// The user wants to switch to automatic mode. Get the current I-frame sector.
	GetSelectedLBA();
	m_Auto = 1;
	MESSAGE2("Switching to automatic frame selection for %s\n",ShrinkEngine->m_InFileName);
	MESSAGEF2("Retour  la slection automatique pour %s\n",ShrinkEngine->m_InFileName);
	OnOK();
}

int CFrameSelectDialog::GetSelectedLBA()
{
	// This returns the selected LBA.
	int Selected;
	if(m_Auto)
	{
		// In automatic mode, we simply return either the default LBA m_DefaultLBA or the one that
		// was previously stored in our cell info.
		SetDefaultLBA();
		return m_DefaultLBA;
	}
	if(m_Kill)
	{
		// Return -1 if m_Kill == 1 and -2 if m_Kill == 2 (kludgy as hell!).
		Selected = - m_Kill;
	}
	else
	{
		// In other cases, let's get the LBA from the preview class.
		m_Preview->WaitForThread();
		Selected = m_Preview->GetCurrentSector();
	}
	// Now store the selected LBA. See if we already have some info available.
	int i;
	for(i=0;i<m_CellInfoSize;i++)
	{
		if(m_VOBID == m_CellInfo[i].VOBID && m_CELLID == m_CellInfo[i].CellID && 
			m_VTSIndex == m_CellInfo[i].VTSIndex)
		{
			// We found the cell in our info. Let's update the selected frame.
			m_CellInfo[i].SelectedFrame = Selected;
			break;
		}
	}
	if(i == m_CellInfoSize && m_CellInfoSize < MAX_NUM_CELL)
	{
		// We didn't find this VCID in our info. Create a new one and store the selected frame.
		m_CellInfo[i].VOBID = m_VOBID;
		m_CellInfo[i].CellID = m_CELLID;
		m_CellInfo[i].VTSIndex = m_VTSIndex;
		m_CellInfo[i].SelectedFrame = Selected;
		m_CellInfoSize++;
	}
	return Selected;
}

void CFrameSelectDialog::OnOK() 
{
	// Remember our position before closing.
	GetWindowRect(&m_MyRect);	
	CDialog::OnOK();
}

void CFrameSelectDialog::OnKill() 
{
	char* Msg;
	// Warn the user.
	if(CurrentLangage == ENGLISH)
		Msg = "WARNING! Killing a cell can break a menu,\nare you sure you want to skip this cell?";
	else
		Msg = "ATTENTION! Enlever une cellule peut rendre le menu inutilisable\nEtes-vous sur de vouloir enleveler la cellule?";
	int ret = AfxMessageBox(Msg, MB_YESNO);
	if(ret != IDYES)
		return;
	m_Kill = 1;
	// Remember our position and close.
	GetWindowRect(&m_MyRect);	
	CDialog::OnOK();
}

void CFrameSelectDialog::OnKeep() 
{
	m_Kill = 2;
	// Remember our position and close.
	GetWindowRect(&m_MyRect);	
	CDialog::OnOK();
}

bool CFrameSelectDialog::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    UINT nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)
    {
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);
		if(CurrentLangage == ENGLISH)
		{
			switch(nID)
			{
			case IDOK : 
				if(!m_NormallySkipped)
					pTTT->lpszText = "Select current frame and continue processing"; 
				else
					pTTT->lpszText = "Shrink and kill the cell (it has no buttons and is useless)"; 
				break; 
			case IDC_ABORT : pTTT->lpszText = "Abort processing"; break; 
			case IDC_SKIP : pTTT->lpszText = "Skip playback of this cell. WARNING! THIS IS DANGEROUS"; break; 
			case IDC_AUTO : 
				if(!m_NormallySkipped)
					pTTT->lpszText = "Select current frame, and switch to automatic mode for this VTS"; 
				else
					pTTT->lpszText = "Kill this cell, and switch to automatic mode for this VTS"; 
				break; 
			case IDC_FRAMESLIDER : pTTT->lpszText = "Move the slider to the desired frame and click OK"; break; 
			case IDC_LEFT : pTTT->lpszText = "Move one I-frame left"; break; 
			case IDC_RIGHT : pTTT->lpszText = "Move one I-frame right"; break; 
			case IDC_START : pTTT->lpszText = "Move one I-frame left"; break; 
			case IDC_END : pTTT->lpszText = "Move one I-frame right"; break; 
			case IDC_KEEP : pTTT->lpszText = "Keep this cell animated (don't shrink)"; break; 
			}
			pTTT->hinst = AfxGetResourceHandle();
			return(TRUE);
		}
		else
		{
			switch(nID)
			{
			case IDOK : 
				if(!m_NormallySkipped)
					pTTT->lpszText = "Choisir l'image courante et continuer le traitement"; 
				else
					pTTT->lpszText = "Enlever compltement cette cellule (elle n'a pas de boutons et ne sert  rien)"; 
				break; 
			case IDC_ABORT : pTTT->lpszText = "Annuler le traitement"; break; 
			case IDC_SKIP : pTTT->lpszText = "Enlever cette cellule. ATTENTION! CELA PEUT ETRE DANGEREUX!"; break; 
			case IDC_AUTO : 
				if(!m_NormallySkipped)
					pTTT->lpszText = "Choisir l'image courante puis continuer en mode automatique"; 
				else
					pTTT->lpszText = "Enlever la cellule puis continuer en mode automatique"; 
				break; 
			case IDC_FRAMESLIDER : pTTT->lpszText = "Choisir l'image dans le menu."; break; 
			case IDC_LEFT : pTTT->lpszText = "Reculer d'une image."; break; 
			case IDC_RIGHT : pTTT->lpszText = "Avancer d'une image"; break; 
			case IDC_START : pTTT->lpszText = "Retourner  la premire image"; break; 
			case IDC_END : pTTT->lpszText = "Aller  la dernire image"; break; 
			case IDC_KEEP : pTTT->lpszText = "Garder la cellule intacte"; break; 
			}
			pTTT->hinst = AfxGetResourceHandle();
			return(TRUE);
		}
    }
    return(FALSE);
}

void CFrameSelectDialog::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);
	// This is needed so the video preview moves with us!!!
	m_Preview->HandleMessage(WM_MOVE,0,0);
}

// This is kludgy and tricky. I don't like it. But is't needed to not get into an infinite loop.
static bool NoAdjust = 0;

void CFrameSelectDialog::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if(!NoAdjust)
	{
		RECT Temp;
		GetWindowRect(&Temp);
		// This allows us to resize vertically based on the horizontal size and the aspect ratio.
		AdjustSize(Temp.right-Temp.left);
	}
}

void CFrameSelectDialog::AdjustSize(int cx)
{
	RECT VideoRect;

	// I'm going to resize the video's x-axis to match the dialog's size, and resize the dialog y size
	// to match the video's!
	int VideoXSize = m_Preview->GetCodedPictureWidth();
	int MyXSize = cx;
	float Scaling = (float)(MyXSize - 15) / m_Preview->GetCodedPictureWidth();
	m_Preview->SetVideoScaling(Scaling,-1);

	::GetWindowRect(m_PreviewHWND,&VideoRect);
	int VideoYSize = VideoRect.bottom - VideoRect.top;
	// Avoid an infinite loop here.
	NoAdjust = 1;
	SetWindowPos(NULL,0,0,MyXSize,VideoYSize+60,SWP_NOZORDER|SWP_NOMOVE);
	NoAdjust = 0;
}


BOOL CFrameSelectDialog::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message == WM_KEYDOWN)
	{
		BOOL CTRLOn;
		switch(pMsg->wParam)
		{
			// Must be all CAPS...
		case VK_LEFT: OnLeft(); break;
		case VK_RIGHT: OnRight(); break;
		case VK_UP: OnEnd(); break;
		case VK_DOWN: OnStart(); break;
		case 'A': OnAuto(); break;
		case 'K': 		
			CTRLOn = (GetAsyncKeyState(VK_CONTROL) & 0x8000);
			if(CTRLOn)
				OnKill(); 
			break;
		default: return CDialog::PreTranslateMessage(pMsg);
		}
		return TRUE;
	}
	else return CDialog::PreTranslateMessage(pMsg);
}

void CFrameSelectDialog::SaveData(char* FullPath)
{
	// This saves our cell info into a file.
	if(m_CellInfoSize == 0)
		return;
	char IFrameFile[MAX_PATH];
	sprintf(IFrameFile,"%s/MenuShrink/IFrameData.txt",getenv("APPDATA"));
	FILE* fd = fopen(IFrameFile,"w");
	if(fd != NULL)
	{
		fprintf(fd,"%s\n",FullPath);
		int i;
		for(i=0;i<m_CellInfoSize;i++)
			fprintf(fd,"%d %d %d %d\n",m_CellInfo[i].VOBID,m_CellInfo[i].CellID,
			m_CellInfo[i].VTSIndex,m_CellInfo[i].SelectedFrame);
		fclose(fd);
	}
}	


void CFrameSelectDialog::LoadData(char* FullPath)
{
	// This loads our cell info from a file.
	char IFrameFile[MAX_PATH];
	sprintf(IFrameFile,"%s/MenuShrink/IFrameData.txt",getenv("APPDATA"));
	FILE* fd = fopen(IFrameFile,"r");
	if(fd != NULL)
	{
		ResetInfo();
		char Temp[MAX_PATH];
		fscanf(fd,"%s",Temp);
		if(strcmp(Temp,FullPath) != 0)
		{
			fclose(fd);
			return;
		}
		int i = 0;
		while(fscanf(fd,"%d %d %d %d\n",&m_CellInfo[i].VOBID,&m_CellInfo[i].CellID,
			&m_CellInfo[i].VTSIndex,&m_CellInfo[i].SelectedFrame) != EOF)
		{
			i++;
		}
		m_CellInfoSize = i;
		fclose(fd);
	}
}

