#include "stdafx.h"
#include "Resource.h"
#include "MiscDialogs.h"
#include "MenuShrinkEngine.h"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

extern CRichEditCtrl*	TheLogEdit;
extern int CurrentLangage;
extern int	ManualSelect;

char* CreditsE = 
"MenuShrink, coded by jeanl, based on an idea suggested by r0lZ. \n\
Many thanks to:\n\n\
Blutach: too many beta testing runs to count! Thanks for suggesting\n\
the cool ""cell skipping"" idea, and the app name. Thanks for the\n\
various encouragements! and best of all, for helping with the user \n\
manual!\n\n\
mpucoder - decisive help with expert assistance at times where\n\
things were complete mysteries, many many thanks man!\n\n\
jsoto - for sharing his knowledge, his code, and for vobblanker which \n\
definitely rules!\n\n\
r0lZ - for suggesting the app in the first place, lots of help in other\n\
decisive moments, and coding PgcEdit which also definitely rules!\n\n\
2COOL - for helping so much on the forum and running many \n\
beta-tests! Keep it up man!\n\n\
Emile my little guy, for the art work! Keep it up too! \n\n";

char* CreditsF = 
"MenuShrink, cod par jeanl, d'aprs une ide suggre par r0lZ. \n\
Merci :\n\n\
Blutach: Impossible de compter les tests Beta! Merci pour l'ide\n\
de la ""cell skipping"", le nom de l'appli. Merci pour les \n\
encouragements! et surtout, pour ton aide avec le manuel utilisateur\n\n\
mpucoder - pour l'aide dcisive et ton expertise quand tout me\n\
semblait compltement mystrieux, merci mille fois!\n\n\
jsoto - pour ton expertise, ton code, et pour vobblanker qui est\n\
vraiment top!\n\n\
r0lZ - pour avoir suggr cette appli il y a longtemps, pour l'aide\n\
aux moments dcisifs, et pour PgcEdit qui est aussi top!\n\n\
2COOL - pour ton activit sur le forum, et les nombreux tests Beta \n\
Continue!\n\n\
Emile mon petit gars, pour l'icne! Keep it up! \n\n";

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}
void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_SHOWWINDOW()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_MANUAL, OnManual)
	ON_BN_CLICKED(IDC_HOME, OnHome)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CAboutDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	if(bShow)
	{
		// Show version
		SetDlgItemText(IDC_VERSION, VERSION);
		// Select the font and start the timer.
		CFont m_font;
		LOGFONT lf;                        
		memset(&lf, 0, sizeof(LOGFONT));   
		lf.lfHeight = 16;                  
		strcpy(lf.lfFaceName, "Eurostile");
		m_font.CreateFontIndirect(&lf);   
		GetDlgItem(IDC_CREDITS)->SetFont(&m_font);
		m_count = 0;
		m_Timer = SetTimer(0,40,NULL);
	}
	else
	{
		KillTimer(m_Timer);
	}
	if(CurrentLangage == FRENCH)
	{
		SetDlgItemText(IDC_STATICBUG,"Pour signaler un bug ou faire une suggestions, email jeanldvd@free.fr");
		SetDlgItemText(IDC_MANUAL,"Manuel utilisateur");
		SetDlgItemText(IDC_HOME,"Page d'accueil");
		SetWindowText("A propos de MenuShrink");
	}
	CDialog::OnShowWindow(bShow, nStatus);
}

void CAboutDlg::OnTimer(UINT nIDEvent) 
{
	// At each timer call, we add one letter.
	char* Credits = CurrentLangage == ENGLISH ? CreditsE : CreditsF;
	if(m_count < (int)strlen(Credits))
	{
		CEdit* TheEdit = (CEdit*) GetDlgItem(IDC_CREDITS);
		int N = TheEdit->GetWindowTextLength();
		TheEdit->SetSel(N,N);	// This selects the '\0'
		char Foo[3]; 
		Foo[0] = Credits[m_count++];
		if(Foo[0] == '\n') {strcpy(Foo,"\r\n");}
		else Foo[1]='\0';
		TheEdit->ReplaceSel(Foo);
	}
	CDialog::OnTimer(nIDEvent);
}

void CAboutDlg::OnManual() 
{
	// This stuff is to load binary data (the user manual) from the resource, quite something!
	LPTSTR Temp1 = MAKEINTRESOURCE(IDR_MANUALBINARY);
	HRSRC Temp2 = FindResource(NULL,Temp1,"BINARY");
	// We'll need to know the size!
	int Size = SizeofResource(NULL,Temp2);
	HGLOBAL Temp3 = LoadResource(NULL,Temp2);
	LPVOID Temp4 = LockResource(Temp3);
	// I'm going to put the manual in the MenuShrink directory.
	char ManualFileName[512];
	sprintf(ManualFileName,"%s/MenuShrink/UserManual.pdf",getenv("APPDATA"));
	FILE* fd = fopen(ManualFileName,"wb");
	if(fd)
	{
		fwrite((char*)Temp4,1,Size,fd);
		fclose(fd);
	}
	// Now let's open the newly created file.
//	sprintf(ManualFileName,"file:%s/MenuShrink/UserManual.pdf",getenv("APPDATA"));
	int ret = (int)ShellExecute(NULL, "open", ManualFileName, NULL, NULL, SW_SHOWNORMAL);
	if(ret < 32)
	{
		AfxMessageBox("Can't open help!!");
	}
}
void CAboutDlg::OnHome() 
{
	ShellExecute(NULL, "open", "http://jean.laroche.free.fr/MenuShrink", NULL, NULL, SW_SHOWNORMAL);
}

//_________________________________________________________


/////////////////////////////////////////////////////////////////////////////
// CAdvancedDlg dialog used for App Advanced

CAdvancedDialog::CAdvancedDialog() : CDialog(CAdvancedDialog::IDD)
{
	//{{AFX_DATA_INIT(CAdvancedDialog)
	//}}AFX_DATA_INIT
	m_WarnAboutPreview = 1;
}

void CAdvancedDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAdvancedDialog)
	DDX_Control(pDX, IDC_VTSLIST, m_VTSList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAdvancedDialog, CDialog)
	//{{AFX_MSG_MAP(CAdvancedDialog)
	ON_BN_CLICKED(IDC_SUBPICFIX, OnSubpicfix)
	ON_BN_CLICKED(IDC_CELLSTILL, OnCellstill)
	ON_BN_CLICKED(IDC_ALL, OnAll)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_NONE, OnNone)
	ON_BN_CLICKED(IDC_SKIPCLIPS, OnSkipclips)
	ON_BN_CLICKED(IDC_MANUALSELECT, OnManualselect)
	ON_LBN_KILLFOCUS(IDC_VTSLIST, OnKillfocusVtslist)
	ON_BN_CLICKED(IDC_PREVIEWALL, OnPreviewAll)
	//}}AFX_MSG_MAP
ON_CONTROL_RANGE(BN_CLICKED, IDC_FRAME1, IDC_FRAME3, OnFrame )
ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnToolTipNotify )
END_MESSAGE_MAP()

void CAdvancedDialog::OnFrame(UINT nID )
{
	switch(nID-IDC_FRAME1)
	{
	case 0: ShrinkEngine->m_FrameSelect = 15 ; break;
	case 1: ShrinkEngine->m_FrameSelect = 85 ;break;
	case 2: ShrinkEngine->m_FrameSelect = 9999 ;break;
	}
}
void CAdvancedDialog::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	ShrinkEngine->m_FrameSelect = ((CSliderCtrl*)pScrollBar)->GetPos();
	char Temp[64];
	sprintf(Temp,"%3d%%",ShrinkEngine->m_FrameSelect);
	SetDlgItemText(IDC_FRAMES,Temp);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CAdvancedDialog::OnSubpicfix() 
{
	ShrinkEngine->m_FixSubPicStops = ((CButton*)GetDlgItem(IDC_SUBPICFIX))->GetCheck() == 1;	
}
void CAdvancedDialog::OnCellstill() 
{
	ShrinkEngine->m_UseInfiniteStills = ((CButton*)GetDlgItem(IDC_CELLSTILL))->GetCheck() == 1;	
}
void CAdvancedDialog::OnSkipclips() 
{
	ShrinkEngine->m_SkipButtonlessCells = ((CButton*)GetDlgItem(IDC_SKIPCLIPS))->GetCheck() == 1;	
}
void CAdvancedDialog::OnPreviewAll() 
{
	ShrinkEngine->m_PreviewAllCells = ((CButton*)GetDlgItem(IDC_PREVIEWALL))->GetCheck() == 1;	
}
void CAdvancedDialog::OnManualselect() 
{
	ManualSelect = ((CButton*)GetDlgItem(IDC_MANUALSELECT))->GetCheck() == 1;
	GetDlgItem(IDC_PREVIEWALL)->EnableWindow(ManualSelect);
	if(m_WarnAboutPreview && ManualSelect == 1)
	{
		m_WarnAboutPreview = 0;
		if(CurrentLangage == ENGLISH)
			AfxMessageBox("The preview window will open for each menu\nwhen you start processing");
		else
			AfxMessageBox("La fentre de visualisation pour choisir l'image s'ouvrira \nlorsque vous commencerez le traitement.");
	}
}
void CAdvancedDialog::OnAll() 
{
	for(int i=0;i<=ShrinkEngine->m_LastVTS;i++)
		ShrinkEngine->m_VTSInfo[i].m_SkipThisVTS = 0;
	UpdateSkips();
}
void CAdvancedDialog::OnNone() 
{
	for(int i=0;i<=ShrinkEngine->m_LastVTS;i++)
		ShrinkEngine->m_VTSInfo[i].m_SkipThisVTS = 1;
	UpdateSkips();
}
void CAdvancedDialog::OnKillfocusVtslist() 
{
	int NVTS = ShrinkEngine->m_LastVTS;
	int i;
	for(i=0;i<=NVTS;i++)
	{
		ShrinkEngine->m_VTSInfo[i].m_SkipThisVTS = !m_VTSList.GetCheck(i);
	}
	UpdateSkips();
}
void CAdvancedDialog::RefreshUI()
{
	((CSliderCtrl*)GetDlgItem(IDC_FRAMESLIDER))->SetPos(ShrinkEngine->m_FrameSelect);
	char Temp[64];
	sprintf(Temp,"%3d%%",ShrinkEngine->m_FrameSelect);
	SetDlgItemText(IDC_FRAMES,Temp);
	((CButton*)GetDlgItem(IDC_SKIPCLIPS))->SetCheck(ShrinkEngine->m_SkipButtonlessCells);
	((CButton*)GetDlgItem(IDC_SUBPICFIX))->SetCheck(ShrinkEngine->m_FixSubPicStops);
	((CButton*)GetDlgItem(IDC_CELLSTILL))->SetCheck(ShrinkEngine->m_UseInfiniteStills);
	((CButton*)GetDlgItem(IDC_MANUALSELECT))->SetCheck(ManualSelect);
	((CButton*)GetDlgItem(IDC_PREVIEWALL))->SetCheck(ShrinkEngine->m_PreviewAllCells);
	
	GetDlgItem(IDC_PREVIEWALL)->EnableWindow(ManualSelect);
	GetDlgItem(IDC_CELLSTILL)->EnableWindow(!ShrinkEngine->m_KeepAudio);
	if(CurrentLangage == FRENCH)
	{
		SetDlgItemText(IDC_STATICSTARTEND,"Dbut                Fin");
		SetDlgItemText(IDC_STATICFRAME,"Slection de l'image");
		SetDlgItemText(IDC_MANUALSELECT,"Sl. avec visu");
		SetDlgItemText(IDC_PREVIEWALL,"Visualiser tous les menus");
		SetDlgItemText(IDC_SUBPICFIX,"Enlever les stops");
		SetDlgItemText(IDC_CELLSTILL,"Menus statiques (pas d'audio)");
		SetDlgItemText(IDC_SKIPCLIPS,"Sauter les clips d'intro");
		SetDlgItemText(IDC_ALL,"Tous");
		SetDlgItemText(IDC_NONE,"Aucun");
		SetDlgItemText(IDC_STATICVTS,"Slection des menus par VTS");
	}
}
void CAdvancedDialog::EnableUI(bool Enable)
{
	if(!Enable)
	{
		for(int i=0;i<=ShrinkEngine->m_LastVTS;i++)
			m_VTSList.Enable(i,0);
	}
	else
		UpdateSkips();

	GetDlgItem(IDC_ALL)->EnableWindow(Enable && ShrinkEngine->m_LastVTS != -1);
	GetDlgItem(IDC_NONE)->EnableWindow(Enable && ShrinkEngine->m_LastVTS != -1);
	GetDlgItem(IDC_FRAMESLIDER)->EnableWindow(Enable); 
	GetDlgItem(IDC_SKIPCLIPS)->EnableWindow(Enable);
	GetDlgItem(IDC_SUBPICFIX)->EnableWindow(Enable);
	GetDlgItem(IDC_PREVIEWALL)->EnableWindow(Enable && ManualSelect);
	GetDlgItem(IDC_MANUALSELECT)->EnableWindow(true);
	GetDlgItem(IDC_CELLSTILL)->EnableWindow(Enable && ShrinkEngine->m_KeepAudio == 0);
}
void CAdvancedDialog::UpdateSkips()
{
	int NVTS = ShrinkEngine->m_LastVTS;
	int i;
	char TempS[256];
	m_VTSList.ResetContent();
	m_VTSList.SetColumnWidth(140);
	sprintf(TempS,"Shrink VMG (%d MB)",ShrinkEngine->m_VTSInfo[0].m_VTSMenuOrigSize/512);
	m_VTSList.AddString(TempS);
	m_VTSList.Enable(0,ShrinkEngine->m_VTSInfo[0].m_VTSMenuOrigSize != 0);
	m_VTSList.SetCheck(0,ShrinkEngine->m_VTSInfo[0].m_SkipThisVTS == 0 &&
		ShrinkEngine->m_VTSInfo[0].m_VTSMenuOrigSize != 0);

	for(i=0;i<=NVTS && i <= 23;i++)
	{
		if(i>0)
		{
			sprintf(TempS,"Shrink VTSM %d (%d MB)",i,ShrinkEngine->m_VTSInfo[i].m_VTSMenuOrigSize/512);
			m_VTSList.AddString(TempS);
			m_VTSList.Enable(i,ShrinkEngine->m_VTSInfo[i].m_VTSMenuOrigSize != 0);
			m_VTSList.SetCheck(i,ShrinkEngine->m_VTSInfo[i].m_SkipThisVTS == 0 &&
				ShrinkEngine->m_VTSInfo[i].m_VTSMenuOrigSize != 0);
			if(i>=23) continue;
		}
	}
}
BOOL CAdvancedDialog::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message == WM_KEYDOWN)
	{
		switch(pMsg->wParam)
		{
		case 'A': OnAll(); break;
		default: return CDialog::PreTranslateMessage(pMsg);
		}
		return TRUE;
	}
	else return CDialog::PreTranslateMessage(pMsg);
}
bool CAdvancedDialog::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    UINT nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)
    {
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);
		if(CurrentLangage == ENGLISH)
		{
			switch(nID)
			{
			case IDC_SKIPCLIPS : pTTT->lpszText = "Attempt to bypass entirely menu intro clips that don't have buttons"; break; 
			case IDC_SUBPICFIX : pTTT->lpszText = "Remove timed stop commands in subpic data. Uncheck if somehow your highlights get messed up"; break; 
			case IDC_CELLSTILL : pTTT->lpszText = "Use infinite still time in menus without audio. Otherwise use original menu length"; break; 
			case IDC_ALL : pTTT->lpszText = "Process all Video Title Sets"; break; 
			case IDC_NONE : pTTT->lpszText = "Process no Video Title Set"; break; 
			case IDC_FRAMESLIDER : pTTT->lpszText = "Selects the position in the menu of the image to use as a still in auto mode."; break; 
			case IDC_MANUALSELECT : pTTT->lpszText = "Preview and select the still frame by hand for every cell that has buttons, otherwise auto mode."; break; 
			case IDC_PREVIEWALL : pTTT->lpszText = "Preview-select all the cells, even those without buttons."; break; 
			case IDC_VTSLIST : pTTT->lpszText = "Select which titleset menu to shrink and which to keep intact."; break; 
			}
			pTTT->hinst = AfxGetResourceHandle();
			return(TRUE);
		}
		else
		{
			switch(nID)
			{
			case IDC_SKIPCLIPS : pTTT->lpszText = "Sauter les intros aux menus, si elles n'ont pas de boutons"; break; 
			case IDC_SUBPICFIX : pTTT->lpszText = "Enlever les stops temporiss dans les menus. Laisser vierge si vos menus ne fonctionnent pas bien. "; break; 
			case IDC_CELLSTILL : pTTT->lpszText = "Pour les menus sans audio, crer un menu statique. Sinon, uiliser la dure originale."; break; 
			case IDC_ALL : pTTT->lpszText = "Traiter tous les menus"; break; 
			case IDC_NONE : pTTT->lpszText = "Ne traiter aucun menus"; break; 
			case IDC_FRAMESLIDER : pTTT->lpszText = "Position de l'image  utiliser pour le menu en mode automatique."; break; 
			case IDC_MANUALSELECT : pTTT->lpszText = "Choisir la position de l'image  la main pour les menus avec boutons. Sinon, mode automatique."; break; 
			case IDC_PREVIEWALL : pTTT->lpszText = "Visualiser tous les menus, mme sans bouton."; break; 
			case IDC_VTSLIST : pTTT->lpszText = "Slectionner quels \"titlesets\" compresser."; break; 
			}
			pTTT->hinst = AfxGetResourceHandle();
			return(TRUE);
		}
    }
    return(FALSE);
}

//_________________________________________________________



BEGIN_MESSAGE_MAP(CLogDialog, CDialog)
	//{{AFX_MSG_MAP(CLogDialog)
	ON_WM_CTLCOLOR()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_SAVELOG, OnSavelog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CLogDialog::CLogDialog() : CDialog(CLogDialog::IDD)
{
	//{{AFX_DATA_INIT(CLogDialog()
	//}}AFX_DATA_INIT
}

void CLogDialog::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	CWnd* Temp = GetDlgItem(IDC_EDITLOG);
	if(Temp)
	{
		RECT MyRect;
		Temp->GetWindowRect(&MyRect);
		POINT TopLeft;
		TopLeft.x = MyRect.left;
		TopLeft.y = MyRect.top;
		ScreenToClient(&TopLeft);
		Temp->SetWindowPos(NULL,0,0,cx-2*TopLeft.x,cy-(int)(2.5*TopLeft.y),SWP_NOMOVE|SWP_NOZORDER);
		Temp = GetDlgItem(IDC_SAVELOG);
		Temp->SetWindowPos(NULL,TopLeft.x,cy-(int)(1.25*TopLeft.y),0,0,SWP_NOSIZE|SWP_NOZORDER);
		if(CurrentLangage == FRENCH)
		{
	// 
			SetDlgItemText(IDC_SAVELOG,"Sauver");
		}
	}
}
void CLogDialog::OnSavelog() 
{
	static CFileDialog FileDialog(FALSE, CString(".txt"), NULL, 
		OFN_NOCHANGEDIR | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, CString("All Files (*.*)|*.*||"));
	if (FileDialog.DoModal() == IDOK)
	{
		FILE* fd = fopen(FileDialog.GetPathName(),"w");
		if(fd == 0)
		{
			ERROR2("Can't open %s for writing\n",FileDialog.GetPathName());
			return;
		}
		int i;
		char Temp[1024];
		for(i=0;i<TheLogEdit->GetLineCount();i++)
		{
			int Ret = TheLogEdit->GetLine(i,Temp,1024); 
			if(Ret>=2) {Temp[Ret-2] = '\n';Temp[Ret-1] = '\0'; fprintf(fd,"%s",Temp);}
		}
		fclose(fd);
	}
}


CPathDialog::CPathDialog() : CDialog(CPathDialog::IDD)
{
	//{{AFX_DATA_INIT(CPathDialog)
	//}}AFX_DATA_INIT

	strcpy(m_Tool1N,"");
	strcpy(m_Tool2N,"");
	strcpy(m_Tool3N,"");
	strcpy(m_Tool4N,"");
	strcpy(m_Tool5N,"");
}
BEGIN_MESSAGE_MAP(CPathDialog, CDialog)
	//{{AFX_MSG_MAP(CPathDialog)
	ON_EN_KILLFOCUS(IDC_SHRINKPATH, OnKillfocusShrinkpath)
	ON_EN_KILLFOCUS(IDC_PREVIEWPATH, OnKillfocusPreviewpath)
	ON_EN_KILLFOCUS(IDC_F1PATH, OnKillfocusF1path)
	ON_EN_KILLFOCUS(IDC_F2PATH, OnKillfocusF2path)
	ON_EN_KILLFOCUS(IDC_F3PATH, OnKillfocusF3path)
	ON_EN_KILLFOCUS(IDC_F4PATH, OnKillfocusF4path)
	ON_EN_KILLFOCUS(IDC_F5PATH, OnKillfocusF5path)
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(BN_CLICKED, IDC_SETPATHSHRINK, IDC_SETPATH5, OnSetpath )
END_MESSAGE_MAP()

void CPathDialog::OnKillfocusShrinkpath() 
{
	GetDlgItemText(IDC_SHRINKPATH,m_PathToShrink,MAX_PATH);
}
void CPathDialog::OnKillfocusPreviewpath() 
{
	GetDlgItemText(IDC_PREVIEWPATH,m_PathToPowerDVD,MAX_PATH);
}

void CPathDialog::RefreshUI()
{
	SetDlgItemText(IDC_SHRINKPATH,m_PathToShrink);
	SetDlgItemText(IDC_PREVIEWPATH,m_PathToPowerDVD);
	SetDlgItemText(IDC_F1PATH,m_Tool1);
	SetDlgItemText(IDC_F2PATH,m_Tool2);
	SetDlgItemText(IDC_F3PATH,m_Tool3);
	SetDlgItemText(IDC_F4PATH,m_Tool4);
	SetDlgItemText(IDC_F5PATH,m_Tool5);
	if(CurrentLangage == FRENCH)
	{
// 
		SetDlgItemText(IDC_STATICPS,"Chemin DVD Shrink");
		SetDlgItemText(IDC_STATICPP,"Chemin Soft Lecteur");
		SetDlgItemText(IDC_STATIC1,"Chemin Outil 1");
		SetDlgItemText(IDC_STATIC2,"Chemin Outil 2");
		SetDlgItemText(IDC_STATIC3,"Chemin Outil 3");
		SetDlgItemText(IDC_STATIC4,"Chemin Outil 4");
		SetDlgItemText(IDC_STATIC5,"Chemin Outil 5");
		SetWindowText("Choisissez les chemins pour les outils");
	}
}
void CPathDialog::OnKillfocusF1path() 
{
	GetDlgItemText(IDC_F1PATH,m_Tool1,MAX_PATH);
}
void CPathDialog::OnKillfocusF2path() 
{
	GetDlgItemText(IDC_F2PATH,m_Tool2,MAX_PATH);
}
void CPathDialog::OnKillfocusF3path() 
{
	GetDlgItemText(IDC_F3PATH,m_Tool3,MAX_PATH);
}
void CPathDialog::OnKillfocusF4path() 
{
	GetDlgItemText(IDC_F4PATH,m_Tool4,MAX_PATH);
}
void CPathDialog::OnKillfocusF5path() 
{
	GetDlgItemText(IDC_F5PATH,m_Tool5,MAX_PATH);
}
void CPathDialog::DoSetPath(char* Tool)
{
	uint i;
	// Annoying. If there's a '/' in the path, the dialog won't open!!
	for(i=0;i<strlen(Tool);i++)
	{
		if(Tool[i] == '/') Tool[i] = '\\';
	}
	CFileDialog FileDialog(TRUE, CString(".exe"), Tool, OFN_NOCHANGEDIR, CString("All Files (*.*)|*.*||"));
	if (FileDialog.DoModal() == IDOK)
		strcpy(Tool,FileDialog.GetPathName());
	RefreshUI();
}

void CPathDialog::OnSetpath(UINT nID) 
{
	switch(nID)
	{
	case IDC_SETPATHSHRINK : DoSetPath(m_PathToShrink); break;
	case IDC_SETPATHPREVIEW : DoSetPath(m_PathToPowerDVD); break;
	case IDC_SETPATH1 : DoSetPath(m_Tool1); break;
	case IDC_SETPATH2 : DoSetPath(m_Tool2); break;
	case IDC_SETPATH3 : DoSetPath(m_Tool3); break;
	case IDC_SETPATH4 : DoSetPath(m_Tool4); break;
	case IDC_SETPATH5 : DoSetPath(m_Tool5); break;
	}
}
